'use strict';

exports.__esModule = true;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _Rx = require('rxjs/Rx');

var _Rx2 = _interopRequireDefault(_Rx);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ob = {};

// eslint-disable-next-line

var _loop = function _loop(p) {
    switch (_typeof(wx[p])) {
        case 'object':
            ob[p] = Object.assign(wx[p]);
            break;
        case 'function':
            if (/Sync$/.test(p)) {
                ob[p] = function (obj) {
                    return _Rx2.default.Observable.of(wx[p].call(null, obj));
                };
            } else {
                ob[p] = function (obj) {
                    return _Rx2.default.Observable.create(function (observer) {
                        var param = Object.assign({}, obj);
                        param.success = function () {
                            return observer.next.apply(observer, arguments);
                        };
                        param.fail = function (e) {
                            return observer.error(e);
                        };
                        param.complete = function () {
                            return observer.complete();
                        };
                        wx[p].call(null, param);
                    });
                };
            }
            break;
        default:
            ob[p] = wx[p];
            break;
    }
};

for (var p in wx) {
    _loop(p);
}

exports.default = ob;
//# sourceMappingURL=rxwx.js.map