'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.createStore = createStore;
exports.combineReducers = combineReducers;
exports.init = init;

var _Rx = require('rxjs/Rx');

var _Rx2 = _interopRequireDefault(_Rx);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createStore(reducer$) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var _options$debug = options.debug,
        debug = _options$debug === undefined ? false : _options$debug;

    var state = {};
    var store$ = new _Rx2.default.BehaviorSubject(state);

    var subscription = reducer$.map(function (reducer) {
        return reducer(state);
    })
    // eslint-disable-next-line no-console
    .do(function (x) {
        return debug && console.log('%c%s', 'color:#61bd4f', '[wx-enhancer-store]: ', x);
    }).subscribe(function (x) {
        state = x;
        store$.next(x);
    });

    return {
        store$: store$,
        getState: function getState() {
            return state;
        },
        unsubcribe: function unsubcribe() {
            subscription.unsubcribe();
            store$.unsubcribe();
        }
    };
}

function combineReducers(reducerMap) {
    var _Rx$Observable;

    var keys = Object.keys(reducerMap);
    var reducers = keys.map(function (k) {
        return reducerMap[k].map(function (r) {
            return function (state) {
                var _extends2;

                return _extends({}, state, (_extends2 = {}, _extends2[k] = r(state[k]), _extends2));
            };
        });
    });
    return (_Rx$Observable = _Rx2.default.Observable).merge.apply(_Rx$Observable, reducers);
}

function init(o$) {
    return o$.map(function (x) {
        return function () {
            return x;
        };
    });
}
//# sourceMappingURL=store.js.map